=== modified file 'ivle/webapp/admin/subject.py'
--- ivle/webapp/admin/subject.py	2010-02-24 12:18:11 +0000
+++ ivle/webapp/admin/subject.py	2010-02-24 12:06:44 +0000
@@ -308,7 +308,7 @@
 
         ctx['worksheets'], problems_total, problems_done = (
             ivle.worksheet.utils.create_list_of_fake_worksheets_and_stats(
-                req.config, req.store, req.user, self.context))
+                req.store, req.user, self.context))
 
         ctx['exercises_total'] = problems_total
         ctx['exercises_done'] = problems_done

=== modified file 'ivle/webapp/admin/templates/offering.html'
--- ivle/webapp/admin/templates/offering.html	2010-02-24 12:18:11 +0000
+++ ivle/webapp/admin/templates/offering.html	2010-02-24 12:09:26 +0000
@@ -90,10 +90,10 @@
         </a>
       </div>
 
-      <div py:if="'edit_worksheets' in permissions or len(worksheets) > 0"
+      <div py:if="'edit_worksheets' in permissions or context.worksheets.count() > 0"
            class="majorsection">
         <h2>Worksheets</h2>
-        <py:choose test="len(worksheets)">
+        <py:choose test="context.worksheets.count()">
           <p py:when="0">
             There are no worksheets for this offering.
             <a class="addaction" href="${req.publisher.generate(context, None, ('+worksheets', '+new'))}">Create one now</a>

=== modified file 'ivle/worksheet/utils.py'
--- ivle/worksheet/utils.py	2010-02-24 12:18:11 +0000
+++ ivle/worksheet/utils.py	2009-12-17 03:56:26 +0000
@@ -331,7 +331,7 @@
 
 
 # XXX: This really shouldn't be needed.
-def create_list_of_fake_worksheets_and_stats(config, store, user, offering):
+def create_list_of_fake_worksheets_and_stats(store, user, offering):
     """Take an offering's real worksheets, converting them into stats.
 
     The worksheet listing views expect special fake worksheet objects
@@ -345,13 +345,7 @@
     problems_total = 0
 
     # Offering.worksheets is ordered by the worksheets seq_no
-    worksheets = offering.worksheets
-
-    # Unless we can edit worksheets, hide unpublished ones.
-    if 'edit_worksheets' not in offering.get_permissions(user, config):
-        worksheets = worksheets.find(published=True)
-
-    for worksheet in worksheets:
+    for worksheet in offering.worksheets:
         new_worksheet = FakeWorksheetForMarks(
             worksheet.identifier, worksheet.name, worksheet.assessable)
         if new_worksheet.assessable:

